/* This file was automatically generated.  Do not edit! */
void net_init_global();
void net_udp_sendf(const char *dest,const char *fmt,...);
void net_udp_send(const char *dest,const char *msg);
void net_udp_send_raw(const char *dest,const char *msg,int len);
typedef struct net net;
void net_connect(struct net *n,const char *addr,int defport,const char *laddr,void(*cb)(struct net *,const char *));
struct net *net_new(void *handle,void(*err)(struct net *,int,const char *));
time_t net_last_activity(struct net *n);
void net_connected(struct net *n,int sock,const char *addr);
void net_settls(struct net *n,gboolean serv,void(*cb)(struct net *,const char *));
void net_shutdown(struct net *n,void(*cb)(struct net *));
void net_sendfile(struct net *n,int fd,int len,gboolean flush,void(*cb)(struct net *));
void net_writef(struct net *n,const char *fmt,...);
void net_writestr(struct net *n,const char *msg);
void net_write(struct net *n,const char *buf,int len);
void net_recvfile(struct net *n,int len,gboolean(*data)(void *,const char *,int),void(*done)(struct net *,void *),void *ctx);
void net_peekbytes(struct net *n,int bytes,void(*cb)(struct net *,char *,int));
void net_readbytes(struct net *n,int bytes,void(*cb)(struct net *,char *,int));
void net_readmsg(struct net *n,unsigned char eom,void(*cb)(struct net *,char *,int));
void net_disconnect(struct net *n);
int net_left(struct net *n);
void net_unref(struct net *n);
#define NETST_IDL 0 // idle, disconnected
#define net_is_idle(n) ((n)->state == NETST_IDL)
#define NETST_DNS 1 // resolving DNS
#define NETST_CON 2 // connecting
#define net_is_connecting(n) ((n)->state == NETST_DNS || (n)->state == NETST_CON)
#define NETST_ASY 3 // connected, handling async messages
#define NETST_SYN 4 // connected, handling a synchronous send/receive
#define net_is_connected(n) ((n)->state == NETST_ASY || (n)->state == NETST_SYN)
#define net_remoteaddr(n) ((n)->addr)
#define net_ref(n) g_atomic_int_inc(&((n)->ref))
struct net {
  int state;

  struct ratecalc *rate_in;
  struct ratecalc *rate_out;

  struct dnscon *dnscon; // state DNS,CON. Setting ->net to NULL 'cancels' DNS resolving.
  int sock; // state CON,ASY,SYN,DIS
  int socksrc; // state CON,ASY,DIS. Glib event source on 'sock'.
  char addr[64]; // state ASY,SYN,DIS

  gnutls_session_t tls; // state ASY,SYN,DIS (only if tls is enabled)
  void (*cb_handshake)(struct net *, const char *); // state ASY, called after complete handshake.
  void (*cb_shutdown)(struct net *); // state DIS, called after complete disconnect.

  gboolean tls_handshake : 8; // state ASY, whether we're handshaking.
  gboolean shutdown_closed : 8; // state DIS, whether shutdown() has been called on the socket.
  gboolean writing : 8; // state ASY. Whether 'socksrc' is write poll event.
  gboolean wantwrite : 8; // state ASY. Whether we want a write on sock.

  GString *rbuf; // state ASY. Read buffer.
  GString *wbuf; // state ASY. Write buffer.

  // Called when an error has occured. Second argument is NETERR_*, third a
  // string representing the error.
  void (*cb_err)(struct net *, int, const char *);

  // Read buffer handling. Callback will be called only once. (State ASY)
  void (*rd_cb)(struct net *, char *, int len);
  gboolean rd_msg : 1; // TRUE: message, rd_dat=EOM; FALSE=bytes, rd_dat=count
  gboolean rd_consume : 1;
  int rd_dat;

  // Synchronous file transfers (SYN state) When set in the ASY state, it means
  // that buffers should be flushed before switching to the SYN state.
  struct synfer *syn;

  // some pointer for use by the user
  void *handle;
  // reference counter
  int ref;

  // Timeout handling
  int timeout_src;
  time_t timeout_last;
  const char *timeout_msg;
};
#define NETERR_TIMEOUT 3
#define NETERR_SEND 2
#define NETERR_RECV 1
#define NETERR_CONN 0
#define NETST_DIS 5 // disconnecting (cleanly)
#define INTERFACE 0
extern struct ratecalc net_in,net_out;
